from collections import deque

from tak.log import LogModule
from tak.server import Server, ServerModule
from tak.http_handler import HttpHandlerModule
from tak.servefiles import ServeFilesModule
from tak.transport import TransportModule
from tak.view import ViewModule


def manage():
    default_modules = deque([
        LogModule,
        ServerModule,
        TransportModule,
        HttpHandlerModule,
        ViewModule,
        ServeFilesModule
    ])

    server = Server('tak-config.cfg', default_modules)
    server.start()


if __name__ == '__main__':
    manage()
