

class HttpErrorHandler:
    def __init__(self, config):
        self.view = config['view']

    def handle_error(self, error):
        status, message = error

        return self.view().render_response('errors/error', {
            'status': status,
            'message': message
        })


class Middleware:
    def __init__(self, config, logger):
        self.config = config
        self.logger = logger

    def handle_request(self, request):
        current_config = self.config.match(request)

        response = None
        for application in current_config['middleware']:
            response = application(current_config).handle(request)
            self.logger.debug('Middleware: %s, returned: %s', application, bytearray(str(response), 'utf-8'))

            if response is not None:
                break

        return response
