import socket


class TcpIpTransport:
    def __init__(self, host, port, max_connections):
        self.host = host
        self.port = port
        self.max_connections = max_connections

    def create_socket(self):
        socket_ = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        socket_.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        socket_.bind((self.host, self.port))
        socket_.listen(self.max_connections)

        return socket_


class TransportModule:
    def process_config(self, config):
        if 'max_connections' not in config:
            config['max_connections'] = 1024

        config['max_connections'] = int(config['max_connections'])

        config['transport'] = TcpIpTransport(config['host'], config['port'], config['max_connections'])
